VERSION 5.00
Begin VB.Form SSLDemo 
   Caption         =   "SSL Demo Client"
   ClientHeight    =   4260
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   7455
   LinkTopic       =   "Form1"
   ScaleHeight     =   4260
   ScaleWidth      =   7455
   StartUpPosition =   3  'Windows-Standard
   Begin VB.TextBox TextUrl 
      Height          =   285
      Left            =   120
      TabIndex        =   0
      Text            =   "https://localhost/"
      Top             =   120
      Width           =   5655
   End
   Begin VB.CommandButton C_Get 
      Caption         =   "Get URL"
      Default         =   -1  'True
      Height          =   285
      Left            =   5880
      TabIndex        =   1
      Top             =   120
      Width           =   1455
   End
   Begin VB.ListBox ListParameter 
      Height          =   1035
      Left            =   120
      TabIndex        =   3
      Top             =   840
      Width           =   7215
   End
   Begin VB.TextBox TextHTTP 
      Height          =   1695
      Left            =   120
      MultiLine       =   -1  'True
      ScrollBars      =   3  'Beides
      TabIndex        =   5
      Top             =   2280
      Width           =   7215
   End
   Begin VB.Label Label1 
      Caption         =   "SSL-Parameter:"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   600
      Width           =   1335
   End
   Begin VB.Label Label2 
      Caption         =   "HTTP-Antwort:"
      Height          =   255
      Left            =   120
      TabIndex        =   4
      Top             =   2040
      Width           =   1455
   End
End
Attribute VB_Name = "SSLDemo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

Private WithEvents client As CSocket
Attribute client.VB_VarHelpID = -1

Private Sub C_Get_Click()

ListParameter.Clear
TextHTTP.Text = ""
Me.Refresh

a$ = TextUrl.Text
Protocol$ = LCase$(parse$(a$, "://"))
Host$ = parse$(a$, "/")
document$ = "/" + a$

If Protocol$ = "https" Then Port% = 443 Else Port% = 80
Screen.MousePointer = 11
client.SSLEnable = Port% = 443
client.SSLCAFile = "..\ca-bundle.crt"
client.Connect Host$, Port%
Do While client.State = sockConnecting: DoEvents: Loop
If client.State = sockConnected Then
   If client.SSLEnable Then
      ListParameter.AddItem "SSLCAFile = " & client.SSLCAFile
      ListParameter.AddItem "SSLCipher = " & client.SSLCipher
      ListParameter.AddItem "SSLSubject = " & client.SSLSubject
      ListParameter.AddItem "SSLIssuer = " & client.SSLIssuer
      ListParameter.AddItem "SSLTrusted = " & client.SSLTrusted
   Else
      ListParameter.AddItem "SSL not used"
   End If
   client.SendData "GET " + document$ + " HTTP/1.0" + vbCrLf
   client.SendData "Host: " + Host$ + vbCrLf
   client.SendData vbCrLf
Else
   ListParameter.AddItem "Cannot Connect"
   Screen.MousePointer = 0
End If

End Sub

Private Sub client_Closed()

Screen.MousePointer = 0

End Sub

Private Sub client_DataArrival(BinData() As Byte, RemoteHostIP As String)

TextHTTP.Text = TextHTTP.Text + StrConv(BinData, vbUnicode)

End Sub

Private Sub Form_Load()

Set client = New CSocket

End Sub

Private Function parse$(ByRef a$, ByVal S$)
   If InStr(a$, S$) Then
      parse$ = Left$(a$, InStr(a$, S$) - 1): a$ = Mid$(a$, InStr(a$, S$) + Len(S$))
   Else
      parse$ = a$: a$ = ""
   End If
End Function

Private Sub Form_Resize()

If Me.ScaleWidth - C_Get.Width > 360 Then TextUrl.Width = Me.ScaleWidth - 360 - C_Get.Width
If Me.ScaleWidth > 240 Then ListParameter.Width = Me.ScaleWidth - 240
If Me.ScaleWidth > 240 Then TextHTTP.Width = Me.ScaleWidth - 240
If Me.ScaleWidth - C_Get.Width > 120 Then C_Get.Left = Me.ScaleWidth - 120 - C_Get.Width
If Me.ScaleHeight - TextHTTP.Top > 120 Then TextHTTP.Height = Me.ScaleHeight - TextHTTP.Top - 120

End Sub

